// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_TOOLITEMGROUP_H
#define _GTKMM_TOOLITEMGROUP_H


#include <glibmm.h>

/*
 * Copyright (C) 2009 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <gtkmm/container.h>
#include <gtkmm/toolitem.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkToolItemGroup GtkToolItemGroup;
typedef struct _GtkToolItemGroupClass GtkToolItemGroupClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class ToolItemGroup_Class; } // namespace Gtk
namespace Gtk
{

/** A ToolItemGroup is used together with ToolPalette to add ToolItems to a 
 * palette-like container with different categories and drag and drop support.
 *
 * @ingroup Widgets
 * @ingroup Containers
 */

class ToolItemGroup : public Container
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef ToolItemGroup CppObjectType;
  typedef ToolItemGroup_Class CppClassType;
  typedef GtkToolItemGroup BaseObjectType;
  typedef GtkToolItemGroupClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~ToolItemGroup();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class ToolItemGroup_Class;
  static CppClassType toolitemgroup_class_;

  // noncopyable
  ToolItemGroup(const ToolItemGroup&);
  ToolItemGroup& operator=(const ToolItemGroup&);

protected:
  explicit ToolItemGroup(const Glib::ConstructParams& construct_params);
  explicit ToolItemGroup(GtkToolItemGroup* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GtkToolItemGroup*       gobj()       { return reinterpret_cast<GtkToolItemGroup*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GtkToolItemGroup* gobj() const { return reinterpret_cast<GtkToolItemGroup*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:

public:
  explicit ToolItemGroup(const Glib::ustring& label = Glib::ustring());

  
  void set_label(const Glib::ustring& label);
  
  void set_label_widget(Widget& label_widget);
  
  void set_collapsed(bool collapsed = true);
  
  void set_ellipsize(Pango::EllipsizeMode ellipsize);
  
  void set_header_relief(ReliefStyle style);

  
  Glib::ustring get_label() const;

  //gtkmmproc error: get_label_widget : method defs lookup failed (1)
  //gtkmmproc error: get_label_widget : method defs lookup failed (1)

  
  bool get_collapsed() const;
  
  Pango::EllipsizeMode get_ellipsize() const;
  
  ReliefStyle get_header_relief() const;

  
  void insert(ToolItem& item, int position);
  
  void set_item_position(ToolItem& item, int position);
  
  int get_item_position(const ToolItem& item);

  
  guint get_n_items() const;

  
  ToolItem* get_nth_item(guint index);
  
  const ToolItem* get_nth_item(guint index) const;

  
  ToolItem* get_drop_item(int x, int y);
  
  ToolItem* get_drop_item(int x, int y) const;

  //gtkmmproc error: label : property defs lookup failed.
  //gtkmmproc error: label-widget : property defs lookup failed.
  //gtkmmproc error: collapsed : property defs lookup failed.
  //gtkmmproc error: ellipsize : property defs lookup failed.
  //gtkmmproc error: header-relief : property defs lookup failed.


};

} // namespace Gtk


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gtk::ToolItemGroup
   */
  Gtk::ToolItemGroup* wrap(GtkToolItemGroup* object, bool take_copy = false);
} //namespace Glib


#endif /* _GTKMM_TOOLITEMGROUP_H */

